\ 2015-10-21 abakus_1.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\ #require shiftregister.fs

\ we need a lookup table in sr.emit to map
\ values (5) to led pattern ($08)
create AbakusDigits
$00  invert , \ 0
$10  invert , \ 1
$30  invert , \ 2
$70  invert , \ 3
$F0  invert , \ 4
$08  invert , \ 5
$18  invert , \ 6
$38  invert , \ 7
$78  invert , \ 8
$F8  invert , \ 9

\ transfer n digits
: type.abakus ( xn-1 .. x0 n -- )
  0 ?do
    dup 0 #10 within if
    else
      drop 0 \ map invalid to zero?
    then
    AbakusDigits + @i   byte>sr
  loop
  sr_latch low sr_latch high
;
\ transfer 1 digit from lookup table
: emit.abakus ( n -- )
  1 type.abakus
;
