\ 2017-07-07  leds.fs --- with more general names
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\ : leds.power.on
\   pwr.leds pin_output  pwr.leds high ;
\ : leds.power.off
\   pwr.leds pin_output  pwr.leds low ;
\ led (-) connected to GND
\ : on  high ;
\ : off low ;
\ led (+) connected to high rail
: on  low ;
: off high ;

: +leds
  led.0 pin_output  led.0 off
  led.1 pin_output  led.1 off
  led.2 pin_output  led.2 off
  led.3 pin_output  led.3 off
;
: -leds
  led.0 pin_input
  led.1 pin_input
  led.2 pin_input
  led.3 pin_input
;
: leds-intro
             #200 ms
  led.0 on   #200 ms
  led.1 on   #200 ms
  led.2 on   #200 ms
  led.3 on   #200 ms
  led.0 off  #200 ms
  led.1 off  #200 ms
  led.2 off  #200 ms
  led.3 off  #200 ms
;
: led.blink ( mask addr -- )
  over over on #100 ms  off #100 ms
;
