\ 2017-11-08 gregorian_lastday_of_month.fs
\
\ Written in 2017 by Erich Wälde <erich.waelde@forth-ev.de>
\
\ To the extent possible under law, the author(s) have dedicated
\ all copyright and related and neighboring rights to this software
\ to the public domain worldwide. This software is distributed
\ without any warranty.
\
\ You should have received a copy of the CC0 Public Domain
\ Dedication along with this software. If not, see
\ <http://creativecommons.org/publicdomain/zero/1.0/>.
\
\
\ words:
\     gregorian_lastday_of_month ( year month -- last_day )

#include leap_year_q.fs

create gregorian_length_of_month
  #31 , #28 , #31 , #30 , #31 , #30 ,
  #31 , #31 , #30 , #31 , #30 , #31 ,

: gregorian_lastday_of_month ( year month -- last_day )
  dup 1-                                \ array starts at 0
  gregorian_length_of_month + @i
  swap #2 = if                          \ if February
    swap leap_year? if                  \   if leap_year
      1+                                \     month += 1
    then                                \
  else                                  \ else
    swap drop                           \   remove year
  then                                  \
;
